Bug 1187534 (CVE-2015-1420) - CVE-2015-1420 kernel: fs/fhandle.c race condition
Summary: CVE-2015-1420 kernel: fs/fhandle.c race condition
Keywords:
Status: CLOSED WONTFIX
Alias: CVE-2015-1420
Product: Security Response
Classification: Other
Component: vulnerability
Version: unspecified
Hardware: All
OS: Linux
low
low
Target Milestone: ---
Assignee: Red Hat Product Security
QA Contact:
URL:
Whiteboard:
Depends On: 1189424 1189425 1189426 1189427 1227417
Blocks: 1187535
TreeView+ depends on / blocked
 
Reported: 2015-01-30 11:11 UTC by Vasyl Kaigorodov
Modified: 2019-09-29 13:27 UTC (History)
40 users (show)

Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-06-02 15:45:23 UTC


Attachments (Terms of Use)

Description Vasyl Kaigorodov 2015-01-30 11:11:29 UTC
A specially crafted user space application may exploit a bug in handle_to_path to copy additional data to a target application.  This defect is caused by the kernel incorrectly assuming that the arguments provided do not change.

This is problematic since the kernel does size verifications only after the first
read, so if the number of extra bytes changes in userspace between the first
and second calls, we'll have an incoherent view of file_handle.

The fix is to read the size once, and copy that over to the final
structure referencing it from that point rather than the value from the application which may change.


The patch is not yet present in official kernel tree:
http://git.kernel.org/cgit/linux/kernel/git/torvalds/linux.git/log/fs/fhandle.c

Proposed Patch:
http://marc.info/?l=linux-kernel&m=142247707318982&w=2

Comment 4 Wade Mealing 2015-04-27 10:24:39 UTC
Statement:

This problem does not affect the Linux kernel packages as shipped with Red Hat Enterprise Linux 5. This issue affects the Linux kernel packages as shipped with Red Hat Enterprise Linux 6, 7 and Red Hat Enterprise MRG-2 kernels.

This has been rated as having Low security impact and is not currently planned to be addressed in future updates. For additional information, refer to the Red Hat Enterprise Linux Life Cycle: https://access.redhat.com/support/policy/updates/errata/.

Comment 5 Wade Mealing 2015-04-27 11:17:21 UTC
This original issue was introduced in commit becfd1f37544798cbdfd788f32c827160fab98c1.  This commit was introduced in Red Hat Enterprise Linux 6 and included in Red Hat Enterprise Linux 7 kernel, Red Hat Enterprise Linux 7 kernel-rt and MRG-2 kernels.  

This does not affect Red Hat Enterprise Linux 5 as it does not contain the commit that introduced the issue.

Comment 6 Petr Matousek 2015-06-02 15:44:29 UTC
Created kernel tracking bugs for this issue:

Affects: fedora-all [bug 1227417]

Comment 8 Fedora Update System 2015-06-20 23:59:19 UTC
kernel-4.0.5-200.fc21 has been pushed to the Fedora 21 stable repository.  If problems still persist, please make note of it in this bug report.

Comment 9 Fedora Update System 2015-06-21 00:31:52 UTC
kernel-4.0.5-300.fc22 has been pushed to the Fedora 22 stable repository.  If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.